function varargout = AMANcontrol(varargin)
% AMANCONTROL MATLAB code for AMANcontrol.fig: GUI for AMAN simulator
% Last Modified by GUIDE v2.5 14-Jun-2016 18:12:00

% Copyright (C) 2010  Anna Thorwart, Evan Livesey & Justin Harris, University of Sydney
% This file and instructions can be downloaded from http://sydney.edu.au/science/psychology/staff/justinh/downloads/

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @AMANcontrol_OpeningFcn, ...
    'gui_OutputFcn',  @AMANcontrol_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before AMANcontrol is made visible.
function AMANcontrol_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<*INUSL>
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to AMANcontrol (see VARARGIN)

% h1=imagesc(peaks)
% set(get(h1,'Parent'),'XTickLabel',[], 'YTickLabel',[])

% create all fields that will contain the user input
handles.stimulusFile=[];
handles.trialsFile=[];
handles.phaseFile=[];
handles.paramFile=[];

set(handles.togglebutton_cancel, 'Value', get(handles.togglebutton_cancel,'Min'),'SelectionHighlight','off');

handles.update={'This is a program to simulate an attention-modulated associative network. '
    'To start, please specify the files defining the stimuli, trials, phases and parameters'
    'by pushing the appriopiate buttons. Then click "Simulate". '};
set(handles.text_output, 'String', handles.update);
% Choose default command line output for AMANcontrol
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = AMANcontrol_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
guidata(hObject, handles);

% --- Executes on button press in pushbutton_stimuli.
function pushbutton_stimuli_Callback(hObject, eventdata, handles) %#ok<*DEFNU>
% hObject    handle to pushbutton_stimuli (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[FileName,PathName] = uigetfile('*.*','Select stimulus definition file') ;

if ischar(FileName)
    handles.stimulusFile=[PathName FileName];
end
handles.update=[handles.update ;['Stimulus definition file: ' handles.stimulusFile]];
set(handles.text_output,'String',handles.update,'ListboxTop',length(handles.update));
guidata(hObject, handles);


% --- Executes on button press in pushbutton_trials.
function pushbutton_trials_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_trials (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[FileName,PathName] = uigetfile('*.*','Select trial definition file') ;
if ischar(FileName)
    handles.trialsFile=[PathName FileName];
end
handles.update=[handles.update ;['Trial definition file: ' handles.trialsFile]];
set(handles.text_output,'String',handles.update,'ListboxTop',length(handles.update));
guidata(hObject, handles);

% --- Executes on button press in pushbutton_phase.
function pushbutton_phase_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_phase (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[FileName,PathName] = uigetfile('*.*','Select phase definition file') ;
if ischar(FileName)
    handles.phaseFile=[PathName FileName];
end

handles.update=[handles.update ;['Phase definition file: ' handles.phaseFile]];
set(handles.text_output,'String',handles.update,'ListboxTop',length(handles.update));

guidata(hObject, handles);

% --- Executes on button press in pushbutton_parameters.
function pushbutton_parameters_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_parameters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[FileName,PathName] = uigetfile('*.*','Select parameter definition file') ;

if ischar(FileName)
    handles.paramFile=[PathName FileName];
end
handles.update=[handles.update ;['Parameter definition file: ' handles.paramFile]];
set(handles.text_output,'String',handles.update,'ListboxTop',length(handles.update));
guidata(hObject, handles);

% --- Executes on button press in togglebutton_cancel.
function togglebutton_cancel_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton_simulate.
function pushbutton_simulate_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_simulate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% check that we have filename  for stimuli, trials, phases and parameters
if isempty(handles.stimulusFile)
    handles.update=[handles.update ; 'No filename for stimuli definition is specified. Please do this first.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));
    guidata(hObject, handles);
    return
elseif isempty(handles.trialsFile)
    handles.update=[handles.update ; 'No filename for trials definition is specified. Please do this first.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));
    guidata(hObject, handles);
    return
elseif isempty(handles.phaseFile)
    handles.update=[handles.update ; 'No filename for phases definition is specified. Please do this first.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));
    guidata(hObject, handles);
    return
elseif isempty(handles.paramFile)
    handles.update=[handles.update ; 'No filename for parameters  is specified. Please specify them first.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));
    guidata(hObject, handles);
    return
end


%% GET STIMULI
stimDef={};

fid=fopen(handles.stimulusFile);
output=textscan(fid, '%s%f%f%f','CommentStyle', '#');
fclose(fid);

handles.update=[handles.update ;'Read stimulus definition...'];
set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));
drawnow

tmp=output;
for kk=2:4 % reshape numerical cell matrices
    tmp{kk}=mat2cell(tmp{1,kk}, ones(size(tmp{1,kk})));
end
stimDef=[tmp{1} tmp{2} tmp{3} tmp{4}];

handles.update=[handles.update ;stimDef(:,1)];
set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow

% check if stimulus name, salience and modality are correct
if any(any(cellfun(@isnan, stimDef(:,2:4))))
    handles.update=[handles.update ;'Please specify name, salience and modality for each stimulus.'];
    set(handles.text_output,'String',handles.update,'ListboxTop',length(handles.update));drawnow
    stimDef={};
elseif any(cellfun(@(x) x<0, stimDef(:,2)))
    handles.update=[handles.update ;'The minimal activation has to be positive.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow
    stimDef={};
elseif any(cellfun(@(x) x<0, stimDef(:,3)))
    handles.update=[handles.update ;'The maximal activation has to be positive.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow
    stimDef={};
elseif any(cellfun(@(x,y) x>y, stimDef(:,2),stimDef(:,3)))
    handles.update=[handles.update ;'The maximal activation has to be higher than the minimal activation.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow
    stimDef={};
elseif any(cellfun(@(x) mod(x,1), stimDef(:,4)))
    handles.update=[handles.update ;'Please use only integer to specify the modality of the stimuli.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow
    stimDef={};
end


%% GET TRIALS
if isempty(stimDef)
    handles.update=[handles.update ; 'Something is wrong with the stimulus definition file or its file path. Check this first.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow
    return
end
stimName=stimDef(:,1);
trialDef={};

fid=fopen(handles.trialsFile);

handles.update=[handles.update ;'Read trial definition...'];
set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow

tline = fgetl(fid);
noTrials=0;
while ischar(tline)
    if isempty(tline) % empty line: do nothing
    elseif strncmp('#',tline,1) %commentary: do nothing
    elseif strncmp('@', tline,1) % trialname
        noTrials=noTrials+1;
        % create trial definition matrixes
        trialDef{noTrials,1}=strcat(regexp(tline,'(?<=@).*', 'match', 'once'));
        % set onset and offset of all stimuli to zero
        trialDef{noTrials,2}=zeros(1,length(stimName));
        trialDef{noTrials,3}=zeros(1,length(stimName));
        % set onset and offset of test interval for all stimulus to zero = nothing is testing in this trial
        trialDef{noTrials,4}=zeros(1,length(stimName));
        trialDef{noTrials,5}=zeros(1,length(stimName));
        testStim=[];
        
        handles.update=[handles.update ;trialDef{noTrials,1}];
        set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));
    elseif strncmp('?', tline,1) % test
        if ~isempty(testStim)
            handles.update=[handles.update ;['There is already a test stimulus in Trial ' trialDef{noTrials,1} '. Any further one will be ignored.']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update)); drawnow; break
        end
        testStim=textscan(tline(2:end), '%s%f%f');
        
        % check if everything is correct
        if any(cellfun(@isempty, testStim))
            handles.update=[handles.update ;['There is no test stimulus in Trial ' trialDef{noTrials,1}'.']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));trialDef={};break;drawnow;
        elseif testStim{2}<0 || isempty(testStim{2})
            handles.update=[handles.update ;['The onset of the test interval of stimulus' testStim{1} ' in ' trialDef{noTrials,1} ' is smaller than 0']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            guidata(hObject, handles);
            trialDef={};break
        elseif testStim{3}<0 | isempty(testStim{3})
            handles.update=[handles.update ;['The offset of the test interval of stimulus' testStim{1,1}{1,1} ' in ' trialDef{noTrials,1} ' is smaller than 0']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            guidata(hObject, handles);
            trialDef={};break
        end
        
        % compare stimulus name in trial file with stimuli specified in
        % stimlus definition
        stimInd=find(strcmp(testStim{1},stimName));
        if isempty(stimInd) % if this stimulus wasn't specified
            handles.update=[handles.update ;['The test stimulus in Trial ' trialDef{noTrials,1} ' is not defined in the stimulus file']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            trialDef={};break
        else %else replace onset and offset values
            trialDef{noTrials,4}(1,stimInd)=testStim{2}; %#ok<*AGROW>
            trialDef{noTrials,5}(1,stimInd)=testStim{3};
        end
    else % stimulus
        %check if there was a trial name specified
        if noTrials<1
            handles.update=[handles.update ;'There must a trial name specified first.'];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            trialDef={};break
        end
        % parse stimulus name and onset and offset
        stimPres=textscan(tline, '%s%f%f');
        % check if everything is correct
        if any(cellfun(@isempty, stimPres))
            handles.update=[handles.update ;['Something is missing in Trial ' trialDef{noTrials,1}]];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            trialDef={};break
        elseif stimPres{2}<0
            handles.update=[handles.update ;['The stimulus onset of ' stimPres{1} ' in ' trialDef{noTrials,1} ' is smaller than 0']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            guidata(hObject, handles);
            trialDef={};break
        elseif stimPres{3}<0
            handles.update=[handles.update ;['The stimulus offset of ' stimPres{1,1}{1,1} ' in ' trialDef{noTrials,1} ' is smaller than 0']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            guidata(hObject, handles);
            trialDef={};break
        end
        
        % compare stimulus name in trial file with stimuli specified in
        % stimlus definition
        stimInd=find(strcmp(stimPres{1},stimName));
        if isempty(stimInd) % if this stimulus wasn't specified
            handles.update=[handles.update ;['A stimulus used in Trial ' trialDef{noTrials,1} ' is not defined in the stimulus file']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            trialDef={};break
        else %else replace onset and offset values
            trialDef{noTrials,2}(1,stimInd)=stimPres{2}; %#ok<*AGROW>
            trialDef{noTrials,3}(1,stimInd)=stimPres{3};
        end
        
        
    end
    % read next line
    tline = fgetl(fid);
end
fclose(fid);

%% GET PHASES

if isempty(stimDef)
    handles.update=[handles.update ; 'No stimuli are specified. Please check the file containing the stimulus definition and the file path.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
    guidata(hObject, handles);
    return
elseif isempty(trialDef)
    handles.update=[handles.update ; 'No trials are specified. Please check the file containing the trial definition and the file path.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
    guidata(hObject, handles);
    return
end

trialName=trialDef(:,1);
phaseDef={};
fid=fopen(handles.phaseFile);

handles.update=[handles.update ;'Read phase definition...'];
set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;

tline = fgetl(fid);
noPhases=0;
while ischar(tline)
    if isempty(tline) % empty line: do nothing
    elseif strncmp('#',tline,1) %commentary: do nothing
        
    elseif strncmp('@', tline,1) % phase name
        noPhases=noPhases+1;
        
       % create phase definition matrices
        % read in name: everything after @ and before white space
        phaseDef{noPhases,1}=regexp(tline,'(?<=@)\w*(?=\s*)', 'match','once');
        % set no of all trials to zero
        phaseDef{noPhases,2}=zeros(1,length(trialName));
        
        % read in frequency of phase
        phaseDef{noPhases,3}=str2double(regexp(tline,'(?<=^@.*\s)\d*', 'match','once'));
        if isnan(phaseDef{noPhases,3})
            handles.update=[handles.update ;['No frequency for phase "' phaseDef{noPhases,1} '" specified.']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            phaseDef={};
            guidata(hObject, handles);
            break
        end
        
        
        handles.update=[handles.update ;phaseDef{noPhases,1}];
        set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
        
    else % trial
        if noPhases<1
            handles.update=[handles.update ;'There must a phase name specified first.'];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            phaseDef={};
            guidata(hObject, handles);
            break
        end
        % parse stimulus name and onset and offset
        trialPres=textscan(tline, '%s%f');
        % check if everything is correct
        if any(cellfun(@isempty, trialPres))
            handles.update=[handles.update ;['Something is missing for phase "' phaseDef{noPhases,1} '".']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            phaseDef={};
            guidata(hObject, handles);
            break
        elseif trialPres{2}<0
            handles.update=[handles.update ;['The frequency of trial "' trialPres{1} '" in "' phaseDef{noPhases,1} '" is smaller than 0']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            phaseDef={};guidata(hObject, handles);break
        end
        
        % compare trial name in phase file with trials specified in
        % trial definition
        trialInd=find(strcmp(trialPres{1},trialName));
        if isempty(trialInd) % if this stimulus wasn't specified
            handles.update=[handles.update ;['A trial used in Phase "' phaseDef{noPhases,1} '" is not defined in the trial file']];
            set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
            phaseDef={};break
        else %else replace onset and offset values
            phaseDef{noPhases,2}(1,trialInd)=trialPres{2}; %#ok<*AGROW>
            
        end
    end
    % read next line
    tline = fgetl(fid);
end
fclose(fid);
if isempty(phaseDef)
    handles.update=[handles.update ; 'No phases are specified. Please check file and path.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
    guidata(hObject, handles);
    return
end
%% GET PARAMETERS
paramDef=struct( 'num_elements', [], ...
    'num_TicksPerTrial', [], ...
    'S_distribution', [], ...
    'norm_within_stim', [], ...
    'norm_within_modality', [], ...
    'norm_across_all', [], ...
    'Power_E', [], ...
    'Power_I', [], ...
    'Power_A', [], ...
    'Growth_E', [], ...
    'Growth_I', [], ...
    'Growth_A', [], ...
    'Decay_E', [], ...
    'Decay_I', [], ...
    'Decay_A', [], ...
    'D', [], ...
    'connect_p', [], ...
    'Weight_AA', [], ...
    'Weight_IA', [], ...
    'Beta_E_pos', [], ...
    'Beta_I_pos', [], ...
    'Beta_E_neg', [], ...
    'Beta_I_neg', [], ...
    'k_V', [], ...
    'k_Alpha', [],...
    'fig_V', [],...
    'fig_E', [],...
    'fig_I', [],...
    'fig_A', [],...
    'fig_CR', [], ...
    'mat_CR', []);


fid=fopen(handles.paramFile);

handles.update=[handles.update ;'Read parameters...'];
set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;

output=textscan(fid, '%s%*s%f','CommentStyle', '#');
fclose(fid);

for pa=1:size(output{1,1},1)
    if ~isfield(paramDef, output{1,1}{pa})
        handles.update=[handles.update ;['The ' num2str(pa) '. parameter name "' output{1,1}{pa} '" does not exist. Please check the spelling.']];
        set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
        paramDef=[];guidata(hObject, handles); return
    else
        paramDef.(output{1,1}{pa})=output{1,2}(pa);
    end
end
%chech if we have enough ticks per trial
if paramDef.num_TicksPerTrial< max(max(cell2mat(trialDef(:,2:5))))
    handles.update=[handles.update ;'The number of time steps in each trial is shorter than at least one stimulus onset or offset.'; 'Please check this.'];
    set(handles.text_output,'String',handles.update, 'ListboxTop',length(handles.update));drawnow;
    paramDef=[];guidata(hObject, handles); return
end


%% SIMULATE
set(handles.togglebutton_cancel, 'Value', get(handles.togglebutton_cancel,'Min'));
handles.update=AMANmodel(handles.text_output, handles.togglebutton_cancel, stimDef, trialDef, phaseDef, paramDef);
set(handles.togglebutton_cancel, 'Value', get(handles.togglebutton_cancel,'Min'),'SelectionHighlight','off');
guidata(hObject, handles);

% --- Executes when user attempts to close figure_main.
function figure_main_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure_main (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);


% --------------------------------------------------------------------
function info_Callback(hObject, eventdata, handles)
% hObject    handle to info (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function web_Callback(hObject, eventdata, handles)
% hObject    handle to web (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
web('https://www.uni-marburg.de/fb04/team-lachnit/mitarbeiter/thorwart/simulators')

% --------------------------------------------------------------------
function instruction_Callback(hObject, eventdata, handles)
% hObject    handle to instruction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
winopen('AMANinstruction.pdf')


% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
% hObject    handle to About (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
msgbox('AMAN 1.1, copyright Dr Anna Thorwart, Philipps-Universitt Marburg (anna.thorwart@staff.uni-marburg.de) & Justin Harris, University of Sydney')
